//  Copyright (C) 2003 Koji Tsukada and Satoru Takabayashi
//      All rights reserved.
//      This is free software with ABSOLUTELY NO WARRANTY.
//
//  You can redistribute it and/or modify it under the terms of
//  the GNU General Public License version 2.

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;

namespace FaceIcon
{
	/// <summary>
	/// SendingForm ̊Tv̐łB
	/// </summary>
	public class SendingForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ProgressBar progressBar;
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		Config config;
		UserProfile userProfile;
		TargetProfile targetProfile;
		private System.Windows.Forms.LinkLabel cancenLabel;
		Thread reporter;

		public SendingForm(Config config, UserProfile userProfile, TargetProfile targetProfile)
		{

			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
			this.config = config;
			this.userProfile = userProfile;
			this.targetProfile = targetProfile;
			reporter = new Thread(new ThreadStart(ReportProgress));
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SendingForm));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.label1 = new System.Windows.Forms.Label();
			this.progressBar = new System.Windows.Forms.ProgressBar();
			this.cancenLabel = new System.Windows.Forms.LinkLabel();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(8, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(48, 48);
			this.pictureBox1.TabIndex = 14;
			this.pictureBox1.TabStop = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(64, 8);
			this.label1.Name = "label1";
			this.label1.TabIndex = 15;
			this.label1.Text = "[𑗐Mł";
			// 
			// progressBar
			// 
			this.progressBar.Location = new System.Drawing.Point(64, 24);
			this.progressBar.Name = "progressBar";
			this.progressBar.Size = new System.Drawing.Size(96, 16);
			this.progressBar.Step = 1;
			this.progressBar.TabIndex = 16;
			// 
			// cancenLabel
			// 
			this.cancenLabel.Location = new System.Drawing.Point(104, 48);
			this.cancenLabel.Name = "cancenLabel";
			this.cancenLabel.Size = new System.Drawing.Size(56, 16);
			this.cancenLabel.TabIndex = 17;
			this.cancenLabel.TabStop = true;
			this.cancenLabel.Text = "LZ";
			this.cancenLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.cancenLabel_LinkClicked);
			// 
			// SendingForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(168, 69);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cancenLabel,
																		  this.progressBar,
																		  this.label1,
																		  this.pictureBox1});
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "SendingForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "SendingForm";
			this.Load += new System.EventHandler(this.SendingForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void SendingForm_Load(object sender, System.EventArgs e)
		{
			try 
			{
				Util.LoadImage(pictureBox1, targetProfile.IconPath);
				Util.LoadIcon(this, targetProfile.IconPath);
				reporter.Start();
			}
			catch
			{
			}
		}

		private void ReportProgress()
		{
			progressBar.Visible = true;
			progressBar.Minimum = 0;
			progressBar.Maximum = 100;
			progressBar.Value = 0;
			progressBar.Step = 1;
         
			for (int x = 0; x < 100; x++)
			{
				progressBar.PerformStep();
				Thread.Sleep(2);
			}
			this.Close();
		}

		private void cancenLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			Application.Exit();
		}
	}
}
